-- Test Vector Verification in VHDL
library std;
use std.textio.all;
library work;
use work.all;
library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;




entity  tester is
end  tester;

architecture tester of tester is

component top
    port(
      SRAM_DATA	 : inout	 std_logic_vector(7 downto 0);
      WR_addr	 : in	 std_logic_vector(6 downto 0);
      RD_addr	 : out	 std_logic_vector(6 downto 0);
      WR_EN	 : in	 std_logic;
      RD_EN	 : in	 std_logic;
      Aclr	 : in	 std_logic;
      WClock	 : in	 std_logic;
      RClock	 : in	 std_logic
        );
   end component;
   -- Signal Declarations for the test bench module
    signal		SRAM_DATA		: std_logic_vector(7 downto 0);
    signal		WR_addr			: std_logic_vector(6 downto 0);
    signal		RD_addr			: std_logic_vector(6 downto 0);
    signal		WR_EN			: std_logic;
    signal		RD_EN			: std_logic;
    signal		Aclr			: std_logic;
    signal		WClock			: std_logic;
    signal		RClock			: std_logic;
    signal              check_clock             : std_logic;     
  

signal force_vector				: std_logic_vector(11 downto 0);	
signal bidi_vector				: std_logic_vector(7 downto 0);
signal output_vector			: std_logic_vector(6 downto 0);
signal k	:std_logic_vector(6 downto 0);
--signal check_clk				:std_logic;
signal HCLOCK : std_logic;
file TestFile: text open read_mode is "Test_Vectors.txt";
	
			


--All the vectors go into IN_VAL function to be converted to binary format

function IN_VAL(v:string) return std_logic_vector is

variable temp_logic: std_logic_vector(v'length-1 downto 0);
variable vl : natural := v'length;
begin
	for i in v'range loop
		if (v(i) ='1') or (v(i)='H') then
			temp_logic(vl-i) := '1';
		elsif (v(i)='0') or (v(i)='L') then
			temp_logic(vl-i) := '0';
   		elsif (v(i)='Z') then
			temp_logic(vl-i) := 'Z';
		else
			temp_logic(vl-i) :=  'X';
		end if;
	end loop;
	return(temp_logic);
end function IN_VAL;


  begin
    udut : top
      port map( SRAM_DATA => SRAM_DATA,
                WR_addr	  => WR_addr,
                RD_addr	  => RD_addr,
                WR_EN	  => WR_EN,
                RD_EN	  => RD_EN,
                Aclr	  => Aclr,
                WClock	  => WClock,
                RClock	  => RClock
               );

WR_addr	<= force_vector(6 downto 0);
WR_EN   <= force_vector(9);
RD_EN   <= force_vector(8);
Aclr    <= force_vector(7);
WClock  <= force_vector(11);
RClock  <= force_vector(10);
SRAM_DATA <= bidi_vector;
	


output_vector <= RD_addr;

--check_clk <= HCLOCK after 15 ns; 

test_vector: process 
variable line_ind: line;
variable pad4: string(1 to 4);
variable o_vector	:string(1 to 7);
variable observe_vector	:std_logic_vector(6 downto 0);
variable f_vector: string(1 to 12);
variable b_vector:string(1 to 8);
begin

 wait until rising_edge(HCLOCK);
 	assert (observe_vector = output_vector)
	report "Oberservation vector does not eqal output vector!!!!!!!"
	Severity FAILURE;
		if not (ENDFILE(TestFile)) then
		readline(TestFile,line_ind);
		read(line_ind,f_vector);
		read(line_ind,pad4);
		read(line_ind,b_vector);
		read(line_ind,pad4);
		read(line_ind,o_vector);     
	wait for 1 ns;
		force_vector <= IN_VAL(f_vector);
	if (WR_EN = '1') then
			   if (RD_EN = '0') then
			   	wait for 10 ns;
			   	bidi_vector <= IN_VAL(b_vector);
			   else
				bidi_vector <= IN_VAL(b_vector);
			   end if;
	else
	bidi_vector <= IN_VAL(b_vector);
	end if;
	
	wait for 8 ns;	
	--	bidi_vector <= IN_VAL(b_vector);
		observe_vector:= IN_VAL(o_vector);
	wait for 1 ns;


	end if;

	k<= observe_vector;
end process test_vector;

  -- HCLOCK
    P_HCLOCK :
    process
    begin
        HCLOCK <= '1';
        wait for 50.000 ns;
        HCLOCK <= '0';
        wait for 50.000 ns;
    end process P_HCLOCK;
 
  end;

